#pragma once


class cMainApp : public IFWin
{
public:
	cMainApp();
	~cMainApp();

	void run();
	void initWindow();
	bool initOCC();
	void cleanup();
	void mainloop();

	void drawFrame();

	void OnError(int error, const char* description);
	void OnWindowResized(int width, int height);
	void OnWindowPos(int xPos, int yPos);
	void OnWindowClose();
	void OnWindowRefresh();
	void OnWindowFocus(bool focused);
	void OnWindowIconify(bool iconified);
	void OnFBResized(int width, int height);






	

	static void s_onWindowResized(GLFWwindow* window, int width, int height);
	static void s_onWindowPos(GLFWwindow* window, int xpos, int ypos);
	static void s_onWindowClose(GLFWwindow* window);
	static void s_onWindowRefresh(GLFWwindow* window);
	static void s_onWindowFocus(GLFWwindow* window, int focused);
	static void s_onWindowIconify(GLFWwindow* window,  int iconified);
	static void s_onFBResized(GLFWwindow* window, int width, int height);
	
	static void s_onMouseButton(GLFWwindow* window, int button, int action, int mods);
	static void s_onMouseMove(GLFWwindow* window, double xpos, double ypos);
	static void s_onMouseScroll(GLFWwindow* window, double xoffset, double yoffset);
	static void s_onMouseEnterLeave(GLFWwindow* window, int entered);

	static void s_onKey(GLFWwindow* window, int key, int scancode, int action, int mods);
	static void s_onChar(GLFWwindow* window, unsigned int c);



	void OnMouseMove(double xpos, double ypos);
	void OnMouseScroll(double xoffset, double yoffset);
	void OnMouseButton(int button, int action, int mods);
	void OnMouseEnterLeave(int entered);

	void OnKey(int key, int scancode, int action, int mods);
	void OnChar(int c);


	const Handle_V3d_Viewer& occV3dViewer() const;
	void setOccV3dViewer(const Handle_V3d_Viewer& viewer);
	const Handle_V3d_View& occV3dView() const;

	//void GizmoEditAll(geoMatrix4 matProj, geoMatrix4 &matTras);

	void SetTheme(long nTema);

	void redraw();
	void fitAll();

	int getWidth();
	int getHeight();

	void rotateXY(double degrees);


	char *getLastErrorDescr();
	long getLastError();

	GLFWwindow* window;
	void *mGlContext;
	ImVec4 bkColor;
	
	Handle_V3d_Viewer m_viewer;
	Handle_V3d_View m_view;
	Handle_OpenGl_Context m_GLcontext;
	Handle_AIS_InteractiveContext mContext;
	Handle_Graphic3d_Camera mCamera;



	bool m_isInitialized = false;
	bool m_needsResize = false;


	bool dragging=false;
	bool rotate=false;
	int mouseX = 0;
	int mouseY = 0;
	int ButtonMouseX = 0;
	int ButtonMouseY = 0;

	//geoMatrix4 geoTransformGizmo;
	bool mSnapTranslation;
	bool mSnapScale;
	bool mSnapRotation;
	float snapValue[5];




};

